Mail::Message::TransferEnc::Base64(3pm)

NAME
Mail::Message::TransferEnc::Base64 - encode/decode base64 message bodies

INHERITANCE
 Mail::Message::TransferEnc::Base64
   is a Mail::Message::TransferEnc
   is a Mail::Reporter

SYNOPSIS
  my Mail::Message $msg = ...;
  my $decoded = $msg->decoded;
  my $encoded = $msg->encode(transfer => 'base64');

DESCRIPTION
Encode or decode message bodies with base64. The e-mail protocol and user agents can not handle binary data. Therefore, binary data -but even sometimes non-binary data- is encoded into ASCII, this is transportable.

Base64 re-groups the bits of bytes, and maps them on characters. The data contains bytes of 8 bits (an octet). These are repacked into groups of 6 bits, pointing in an array of characters containing "[A-Za-z0-9+/]". This way, three data bytes become 4 base64 bytes. The encoded data will be trailed by '=' characters to align on four bytes.

Extends "DESCRIPTION" in Mail::Message::TransferEnc.

METHODS
Extends "METHODS" in Mail::Message::TransferEnc.

  Constructors
Extends "Constructors" in Mail::Message::TransferEnc.

$class->new(%options)
    Inherited, see "Constructors" in Mail::Reporter

  Attributes
Extends "Attributes" in Mail::Message::TransferEnc.

  The Encoder
Extends "The Encoder" in Mail::Message::TransferEnc.

$class->addTransferEncoder($type, $class)
    Inherited, see "The Encoder" in Mail::Message::TransferEnc

$obj->create($type, %options)
    Inherited, see "The Encoder" in Mail::Message::TransferEnc

$obj->name()
    Inherited, see "The Encoder" in Mail::Message::TransferEnc

  Encoding
Extends "Encoding" in Mail::Message::TransferEnc.

$obj->check($body, %options)
    Inherited, see "Encoding" in Mail::Message::TransferEnc

$obj->decode($body, %options)
    Inherited, see "Encoding" in Mail::Message::TransferEnc

     -Option     --Defined in                --Default
      result_type  Mail::Message::TransferEnc  <type of source body>

    result_type => CLASS
$obj->encode($body, %options)
    Inherited, see "Encoding" in Mail::Message::TransferEnc

  Error handling
Extends "Error handling" in Mail::Message::TransferEnc.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Message::TransferEnc.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Reporter

DIAGNOSTICS

Warning: Base64 line length not padded on 4.
    While decoding base64 the data in a message body, a string was found which was not padded into a multiple of four bytes. This is illegal, and therefore this data is ignored. Cast by decode()

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

Error: decoder for transfer encoding $type does not work: $@
    Compiling the required transfer encoding resulted in errors, which means that the decoder can not be used. Cast by create()

Error: no decoder for transfer encoding $type.
    A decoder for the specified type of transfer encoding is not implemented. Cast by create()

SEE ALSO
This module is part of Mail-Message version 4.03, built on January 26, 2026. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.